'
'  This is a simple example MAIN routine to (hopefully) show how to use
' the QBXMS routines.
'
'  Put the contents of QBXMS.INC here.
'
'  Dimension four different XMS arrays, one each for the four different
' supported data types.  Don't process arrays past the point at which the
' last call to DIMXMS detected a problem accessing XMS.
'
DIM ADD1 AS LONG,ADD2 AS LONG,ADD3 AS LONG,ADD4 AS LONG
DIM V AS INTEGER    'For call to PUTINT.
EC2=1 : EC3=1 : EC4=1  'Default values in case they don't get set below.
CALL DIMXMS("A1",100000&,"INTEGER",ERRORCODE)
EC1=ERRORCODE
IF EC1=0 THEN
CALL DIMXMS("A2",100000&,"LONG",ERRORCODE)
EC2=ERRORCODE
IF EC2=0 THEN
CALL DIMXMS("A3",100000&,"SINGLE",ERRORCODE)
EC3=ERRORCODE
IF EC3=0 THEN
CALL DIMXMS("A4",100000&,"DOUBLE",ERRORCODE)
EC4=ERRORCODE
IF EC4<>0 THEN
PRINT "Couldn't handle more than three 100000-element XMS arrays."
END IF
ELSE
PRINT "Couldn't handle more then two 100000-element XMS arrays.
END IF
ELSE
PRINT "Can't handle more than one 100000-element XMS array."
END IF
ELSE
PRINT "Do you have XMS?"
END IF
IF EC1=0 THEN
PRINT
PRINT "  Patience.  If your computer isn't rebooting and you don't see a ";
PRINT "question"
PRINT "about your having XMS, QBXMS appears to be working."
PRINT
'
'  Put miscellaneous data in XMS arrays.
'
FOR I=1 TO 100000
'
'  Can't have INTEGERs greater than 32767.
'
V=32767
IF I<32768 THEN V=CINT(I)
CALL PUTINT("A1",CLNG(I),V)
IF EC2=0 THEN CALL PUTLNG("A2",CLNG(I),CLNG(I))
IF EC3=0 THEN CALL PUTSNG("A3",CLNG(I),SQR(I))
IF EC4=0 THEN CALL PUTDBL("A4",CLNG(I),CDBL(SQR(I)))
NEXT I
'
'  Retrieve XMS data and print out screenful.
'
FOR I=1 TO 100000 STEP 5000
IF EC1=0 THEN PRINT GETINT("A1",CLNG(I)),
IF EC2=0 THEN PRINT GETLNG("A2",CLNG(I)),
IF EC3=0 THEN PRINT GETSNG("A3",CLNG(I)),
IF EC4=0 THEN
PRINT GETDBL("A4",CLNG(I))
ELSEIF EC1=0 OR EC2=0 OR EC3=0 THEN
PRINT
END IF
NEXT I
'
'  Verify that function UXMS works.
'
PRINT
PRINT "Array sizes and addresses from UXMS:"
PRINT "Names = ";"A1","A2","A3","A4"
PRINT "Elements = ";UXMS("A1",ADD1),UXMS("A2",ADD2),UXMS("A3",ADD3),
PRINT UXMS("A4",ADD4)
PRINT "Addresses = ";ADD1,ADD2,ADD3,ADD4
END IF
END
'
'  Put the contents of QBXMS.BAS here.
